#!/usr/bin/perl

##
# by Thomas Koch <tom@linvdr.org>
##
use POSIX qw(strftime sprintf);

my $PROC_ALARM = "/proc/acpi/alarm";
my $DEBUG = 0;

sub dprint {
  $_ = join("", @_);
  chomp;
  print "$_\n" if($DEBUG);
}

sub setTime {
  system("hwclock -w");
}

sub setAlarm {
  my $Next = shift;
  setTime();
  dprint("Next event at ", strftime("%d.%m.%Y %H:%M", localtime($Next)));
  system(sprintf("echo \"%s\" > %s", strftime("%Y-%m-%d %H:%M:00", localtime($Next)), $PROC_ALARM));
  system(sprintf("echo \"%s\" > %s", strftime("%Y-%m-%d %H:%M:00", localtime($Next)), $PROC_ALARM));
  system(sprintf("echo \"%s\" > /tmp/a", strftime("%Y-%m-%d %H:%M:00", localtime($Next))));
  system(sprintf("echo \"WakeUp at %s\" >>/tmp/a", strftime("%Y-%m-%d %H:%M:00", localtime($Next))));
}

sub PowerOff {
#  system("/bin/busybox poweroff") if(!$DEBUG);
}

if(scalar(@ARGV)) {
  # called from vdr
  die "Wrong parameter count\n" if(scalar(@ARGV) != 3);
  die "$PROC_ALARM missing" if(!-e $PROC_ALARM);

  my($Next, $Delta, $Channel) = @ARGV;

  setAlarm($Next) if($Next);
} else {
  # called from cmdline
  $next = `svdrpsend.pl next abs`;
  if($next =~ /550 No active timers/) {
    # XXX turns alarm off, at least, i hope so
    #system("echo \"0003-10-20 99:00:00\" > /proc/acpi/alarm");
    setTime();
    PowerOff();
  } elsif($next =~ /250 \d+ (\d+)/) {
    setAlarm($1);
    PowerOff();
  } else {
    print "HELP! What to do? ($next)\n";
  }
}	
